//
// logline.h
//
//
// 
//        Flog 0.5
// 
// 
//                                       ani joshi
//                                       Mark Coletti
//

#ifndef LOGLINE_H
#define LOGLINE_H

#include <string>


class istream;



//
// Class for each ftp xferlog entry
//
class Logline
{
public:

  Logline();

  string const & time() const { return time_; }

  string const & weekday() const { return weekday_; }

  string const & month() const { return month_; }

  int day() const { return day_; }

  int year() const { return year_; }

  string date() const;

  int xfertime() const;

  int xfersize() const;

  // XXX in bytes/sec ??
  float speed() const;

  string const & filename() const;

  string const & ip() const;

  string const & email() const;

  string const & userid() const;

  bool compressed() const;
  bool tarred() const;
  bool uncompressed() const;

  bool ascii() const;
  bool binary() const;

  bool outgoing() const;
  bool incoming() const;

  bool anonymous() const;
  bool guest() const;
  bool user() const;

  bool rfc931() const;

  string& service() const;

private:

  string weekday_, month_, time_, ip_, file_, email_, service_, userid_;

  int day_, year_, xfertime_, xfersize_;

  float speed_;

  bool               compressed_;
  bool               tarred_;

  bool               ascii_;

  bool               outgoing_;

  bool               anonymous_;
  bool               guest_;
  bool               user_;

  bool               rfc931_;

  friend istream& operator>>( istream &, Logline& );
  friend ostream& operator<<( ostream & os, Logline const& ll );

}; // class Logline

#endif
